import processing.serial.*;

Serial port;

int X;
int Y;
int Z;

float a;                          // Angle of rotation
float offset = PI/24.0;             // Angle offset between boxes
int num = 1;                     // Number of boxes

boolean pink = true;

void setup() 
{ 
  size(800, 600, P3D);
  noStroke();  
  lights();

  // establish serial port connection
  println(Serial.list());
  port = new Serial(this, Serial.list()[1], 115200);
  port.clear();
} 


void draw() 
{     
  background(0, 0, 26);
  translate(width/2, height/2);

  while(port.available() == 0){
  }

  char reading = 0;

  while (reading != 'x') {
    while(port.available() == 0){
    }
    reading = (char)port.read();
  }
  X = port.read();
  while (reading != 'y') {
    while(port.available() == 0){
    }
    reading = (char)port.read();
  }
  Y = port.read();
  while (reading != 'z') {
    while(port.available() == 0){
    }
    reading = (char)port.read();
  }
  Z = port.read();

  //println(X);
  //println(Y);
  //println(Z);

  {
    pushMatrix();
    stroke(0);
    rotateY((float)X/50.0);
    rotateX((float)Z/50.0);
    rotateZ((float)Y/50.0);
    scale(90);
    beginShape(QUADS);

    fill(0, 1, 1); 
    vertex(-1,  1,  1);
    fill(1, 1, 1); 
    vertex( 1,  1,  1);
    fill(1, 0, 1); 
    vertex( 1, -1,  1);
    fill(0, 0, 1); 
    vertex(-1, -1,  1);

    fill(1, 1, 1); 
    vertex( 1,  1,  1);
    fill(1, 1, 0); 
    vertex( 1,  1, -1);
    fill(1, 0, 0); 
    vertex( 1, -1, -1);
    fill(1, 0, 1); 
    vertex( 1, -1,  1);

    fill(1, 1, 0); 
    vertex( 1,  1, -1);
    fill(0, 1, 0); 
    vertex(-1,  1, -1);
    fill(0, 0, 0); 
    vertex(-1, -1, -1);
    fill(1, 0, 0); 
    vertex( 1, -1, -1);

    fill(0, 1, 0); 
    vertex(-1,  1, -1);
    fill(0, 1, 1); 
    vertex(-1,  1,  1);
    fill(0, 0, 1); 
    vertex(-1, -1,  1);
    fill(0, 0, 0); 
    vertex(-1, -1, -1);

    fill(0, 1, 0); 
    vertex(-1,  1, -1);
    fill(1, 1, 0); 
    vertex( 1,  1, -1);
    fill(1, 1, 1); 
    vertex( 1,  1,  1);
    fill(0, 1, 1); 
    vertex(-1,  1,  1);

    fill(0, 0, 0); 
    vertex(-1, -1, -1);
    fill(1, 0, 0); 
    vertex( 1, -1, -1);
    fill(1, 0, 1); 
    vertex( 1, -1,  1);
    fill(0, 0, 1); 
    vertex(-1, -1,  1);

    endShape();
    popMatrix();
  }
} 

